"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

// Generated by CoffeeScript 2.0.2
var _print, test, timeout;

require("colors");

timeout = function timeout(t, promise) {
  var timer;
  timer = new Promise(function (_, reject) {
    return setTimeout(function () {
      return reject(new Error("Async test timed out"));
    }, t);
  });
  return Promise.race([timer, promise]);
};

// TODO: use explicit result objects, instead of true | Error | undefined
exports.test = test = (() => {
  var _ref = _asyncToGenerator(function* (description, definition) {
    var error, result;
    if (definition != null) {
      if (Array.isArray(definition)) {
        return [
        // TODO: include error/timeout/pending count in result object
        description, yield _asyncToGenerator(function* () {
          var i, len, results;
          results = [];
          for (i = 0, len = definition.length; i < len; i++) {
            result = definition[i];
            results.push((yield result));
          }
          return results;
        })()];
      } else if (definition.call != null) {
        try {
          yield timeout(1000, definition());
          return [description, true];
        } catch (error1) {
          error = error1;
          return [description, error];
        }
      } else {
        return [description, new Error("Invalid test definition")];
      }
    } else {
      return [description, void 0];
    }
  });

  return function test(_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();

// TODO: add error counts for groups
// TODO: groups with failing/pending tests should be red
exports.print = _print = function print([description, result], indent = "") {
  var i, len, ref, results;
  if (Array.isArray(result)) {
    console.log(indent, description.blue);
    results = [];
    for (i = 0, len = result.length; i < len; i++) {
      exports.test = test = result[i];
      results.push(_print(test, indent + "  "));
    }
    return results;
  } else {
    return console.log(indent, result != null ? result === true ? description.green : result.message != null && result.message !== "" ? `${description.red} (${(ref = result.message) != null ? ref.red : void 0})` : description.red : description.yellow);
  }
};

exports.test = test;
exports.print = _print;